$(document).ready(function() {
  var tasks;

  $("#addTask").click(function() {
    var task = $("#task").val().trim();
    var messageDiv = $("#message");

    // Clear previous messages
    messageDiv.html("");
    messageDiv.removeClass("success");
    messageDiv.removeClass("error");

    // If no text was provided display error message and end execution.
    if (task.length === 0) {
      messageDiv.html("Please provide some text for the task.");
      messageDiv.addClass("error");
      return;
    }

    addTask(task);
  });
  
  $('input').keypress(function (e) {
  if (e.which === 13) {
    $("#addTask").click();
  }
});

  loadTasks();
  displayTasks();
});

function loadTasks() {
  var storedTasks = localStorage.getItem("tasks");

  if (storedTasks === null) {
    tasks = new Array;
  } else {
    tasks = JSON.parse(storedTasks);
  }
}

function displayTasks() {
  for (i = 0; i < tasks.length; i++) {
    appendTaskToList(i, tasks[i]);
  }
}

function appendTaskToList(taskId, task) {
  var todoList = $("#tasks");
  var liId = "task_" + taskId;
   
  todoList.append("<li id=\"" + liId + "\" onClick=\"toggleTaskCompletion('" + liId + "')\">" + task.name + "</li>");
  
  if (task.complete === true) {
    $("#" + liId).addClass("completedTask");
  }
}

function addTask(name) {
  // alert("Add Task");

  var newTask = new Task(name);
  tasks.push(newTask);
  appendTaskToList(tasks.length - 1, newTask);
  localStorage.setItem("tasks", JSON.stringify(tasks));

  $("#task").val("");

  var messageDiv = $("#message");
  messageDiv.html("Task added successfully.");
  messageDiv.addClass("success");
}

function toggleTaskCompletion(liId) {
  var taskId = Number(liId.split("_")[1]);
  
  tasks[taskId].complete = !tasks[taskId].complete;
  localStorage.setItem("tasks", JSON.stringify(tasks));
  $("#" + liId).toggleClass("completedTask");
}

function Task(name) {
  this.name = name;
  this.complete = false;
}