﻿(function () {
    var accessToken = null;

    $(document).ready(function () {
        $("#getAccessToken").click(GetAccessToken);
        $("#createPost").click(AddPost);

        LoadPosts();
        accessToken = GetAccessTokenFromHash();

        ShowAddPost();
    });

    function GetAccessTokenFromHash() {
        return GetHashParam("access_token");
    }

    function LoadPosts() {
        $.ajax({
            method: "GET",
            url: "https://public-api.wordpress.com/rest/v1.1/sites/hgasite.wordpress.com/posts/?number=15",
            dataType: "json",
            success: (function (result) {
                ProcessPosts(result);
            }
            ),
            error: (function () {
                var errorMessage = "Unable to get Posts";
                DisplayMessage(errorMessage);
            })
        });
    }

    function ProcessPosts(data) {
        var postIndex;

        $("#tableBody").empty();

        for (postIndex in data.posts) {
            $("#tableBody").append("<tr><td>" + data.posts[postIndex].title + "</td>" +
                "<td>" + data.posts[postIndex].content + "</td></tr>");
        }
    }

    function AddPost() {
        // Disable submit button
        $("#createPost").attr("disabled", "disabled");

        $.ajax({
            type: "POST",
            url: "https://public-api.wordpress.com/rest/v1.1/sites/106581579/posts/new",
            dataType: "json",
            headers: { "Authorization": "BEARER " + decodeURIComponent(accessToken) },
            data: {
                title: $("#newPostTitle").val(),
                content: $("#newPostContent").val()
            },
            success: (function (result) {
                ProcessAddPost(result);
            }
            ),
            error: (function (result) {
                var errorMessage;

                if (result.responseJSON) {
                    errorMessage = "An error occurred while getting the authorization token: "
                        + result.responseJSON.error + ", " + result.responseJSON.error_description;
                } else {
                    errorMessage = "An error occurred while getting the authorization token: Unexpected Error.";
                }

                DisplayMessage(errorMessage);

                $("#createPost").removeAttr("disabled");
            })
        });
    }

    function ProcessAddPost() {
        LoadPosts();

        DisplayMessage("Blog Post added successfully.");
        $("#createPost").removeAttr("disabled");
    }

    function GetAccessToken() {
        location.href = "https://public-api.wordpress.com/oauth2/authorize?client_id=44958&" +
             "redirect_uri=http://localhost:57159/Html/RestClient2.html&response_type=token&scope=global";
    }

    function ShowAddPost() {
        if (accessToken) {
            $("#getAccessToken").hide();
            $("#addPost").show();
        } else {
            $("#getAccessToken").show();
            $("#addPost").hide();
        }
    }

    function DisplayMessage(error) {
        $("#status").html(error);
    }

    function GetHashParam(sParam) {
        var sPageURL = window.location.hash.substring(1);
        var sURLVariables = sPageURL.split("&");

        for (var i = 0; i < sURLVariables.length; i++) {
            var sParameterName = sURLVariables[i].split("=");
            if (sParameterName[0] === sParam) {
                return sParameterName[1];
            }
        }

        return undefined;
    }
}());