﻿"use strict";

midtermApp.controller("loginController",
    ["$scope", "$routeParams", "$location", "midtermService",
    function detailsController($scope, $routeParams, $location, midtermService) {
        $scope.submitAttempted = {};

        var validForm = function(form) {
            $scope.submitAttempted[form] = true;

            if ($scope[form].$invalid) {
                return false;
            }

            return true;
        };

        var verifyForm = function(form) {
            $scope.successMessage = "";

            if (!validForm(form)) {
                return false;
            }

            return true;
        };

        function displayErrorMessage(message) {
            $scope.errorMessage = message;
        }

        function displaySuccessMessage(message) {
            $scope.successMessage = message;
        }

        var onVerifyCredentialsSuccess = function (result) {
            if (result.data === "Success") {
                // Save authentication token
                midtermService.setAccessData(result.data, $scope.userName);

                // Redirect to private page
                $location.path("/Account");
                return;
            }

            displayErrorMessage("Invalid credentials. Please try again.");
        };

        var onError = function (result) {
            var statusText = result.statusText;

            if (result.status === -1 && statusText === "") {
                statusText = "Server Unavailable.";
            }

            displayErrorMessage(result.status + " " + statusText);
        };

        $scope.login = function () {
            if (!verifyForm("loginForm")) {
                // Form is not valid
                return;
            }

            // Verify Credentials
            midtermService.verifyCredentials($scope.userName, $scope.password).then(onVerifyCredentialsSuccess, onError);
        };

        if ($routeParams.id === "1") {
            displayErrorMessage("Unauthorized access. Please login and try again.");
        }
    }]);