﻿"use strict";

midtermApp.factory("midtermService",
    ["$http",
    function ($http) {
        var isAuthenticated = function() {
            return sessionStorage.accessData !== undefined &&
                sessionStorage.accessData !== "" &&
                sessionStorage.accessData !== "null";
        };

        var getAccessData = function () {
            var accessData = JSON.parse(sessionStorage.getItem("accessData"));
            return accessData;
        };

        var setAccessData = function (accessToken, userName) {
            var accessData = { accessToken: accessToken, userName: userName };
            sessionStorage.setItem("accessData", JSON.stringify(accessData));
        };

        var clearAccessData = function () {
            sessionStorage.accessData = null;
        };

        var verifyCredentials = function (userName, password) {
            var requestUrl = "http://mm214.com/javascript2/week5/auth.php";

            var data = "username=" + userName + "&password=" + password;

            return $http({
                method: "POST",
                url: requestUrl,
                data: data,
                headers: { "Content-Type": "application/x-www-form-urlencoded" }
            });
        };

        return {
            isAuthenticated: isAuthenticated,
            getAccessData: getAccessData,
            setAccessData: setAccessData,
            verifyCredentials: verifyCredentials,
            clearAccessData: clearAccessData
        }
    }]);