<?php
/* 
 *  Author:     Alan Taran
 *  Class:      JavaScript 2
 *  Project:    Final Project
 *  Date:       March 2016
 *  Remarks:    store user activity to database
 */

include 'heatmapdatabase.php';

// create instance of database
$db = new HeatmapDB();

// create table if not created
$db->createTable();

$jsonRequset = $_POST["userActivity"];
$request = json_decode($jsonRequset, true);


$returnMsg = array();

if ($request['event'] === 'click') {
    foreach($request['data'] as $req) {
        $msg = $db->addActivity('click', $req['grid'], $req['X'], $req['Y'], 1);
        $returnMsg[] = $msg;        
    }
}

if ($request['event'] === 'move') {
    // merge activity before adding to database to speed up processing
    $mergeData = array();
    $reqData = $request['data'];
    $mergeData[] = $reqData[0];
    
    for ($i = 1; $i < count($reqData); $i++) {
        for ($ix = 0; $ix < count($mergeData); $ix++) {
            if ($reqData[$i]['grid'] === $mergeData[$ix]['grid'] &&
                    $reqData[$i]['X'] === $mergeData[$ix]['X'] &&
                    $reqData[$i]['Y'] === $mergeData[$ix]['Y']) {
                $mergeData[$ix]['time'] += $reqData[$i]['time'];
                $ix = count($mergeData);
            } else if ($ix === count($mergeData) - 1) {
                $mergeData[] = $reqData[$i];
                $ix++;
            }
        }
    }
    // add/update database
    foreach ($mergeData as $md) {
        $msg = $db->addActivity('move', $md['grid'], $md['X'], $md['Y'], $md['time']);
        $returnMsg[] = $msg;
    }    
} 

echo json_encode($returnMsg);

?>
